const http = require('http');
const querystring = require('querystring');

// The URLs that are shortened.
const short = {};

// Generates a unique URL for a website.
const gen = function generateUrl(length) {
  const h = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
  let url = '';
  for (let i = 0; i < length; i += 1) {
    url += h[Math.floor(Math.random() * 61)]
  }

  // Returns the random string of characters.
  return url;
};

// Creates an HTTP server.
const server = http.createServer((request, response) => {
  if (request.method === 'POST') {
    let body = '';
    request.on('data', chunk => {
      body += chunk.toString(); // convert Buffer to string
    });

    //
    request.on('end', () => {
      console.log(body);
      const code = gen(6);
      const parsed = querystring.parse(body);
      short[code] = parsed.url;
      console.log(short[code]);
      response.end(`<!DOCTYPE html><html><head><title>shorter url</title></head><body><script>alert('Shortened URL for ${parsed.url} is: http://nate.ml/${code}')</script></body></html>`);
    });
  } else {
    if (request.url === '/') {
      // Gives a website.
      response.writeHead(200, {'content-type': 'text/html'});
      response.end(`
        <!DOCTYPE html>
        <html>
          <head>
            <title>shorter url pepega</title>
          </head>
          <body>
            <p>Please enter the URL that you want to shorten.</p>
            <form action="/" method="post">
              <input name="url" placeholder="Website URL" type="text" /> <input type="submit" value="Shorten!" />
            </form>
          </body>
        </html>
      `);
    } else {
      // Serves the shortened website. If not exist, redirect back to site.
      console.log(short[request.url.substr(1)]);
      if (typeof short[request.url.substr(1)] === 'string') {
        console.log('success');
        response.writeHead(302, {'content-type': 'text/html'});
        response.end(`
          <!DOCTYPE html>
          <html>
            <head>
              <meta http-equiv="refresh" content="0; URL=${short[request.url.substr(1)]}" />
            </head>
          </html>
        `);
      } else {
        console.log('fail');
        response.writeHead(404, {'content-type': 'text/html'});
        response.end('');
      }
    }
  }
});

// Makes the HTTP server listen on the given port.
server.listen(80, '0.0.0.0', () => {
  console.log('server on 0.0.0.0:80');
});
